#include <msp/core/refptr.h>
#include <msp/io/file.h>
#include "oggdecoder.h"
#include "sounddecoder.h"

using namespace std;

namespace Msp {
namespace AL {

unsupported_sound::unsupported_sound(const string &w):
	runtime_error(w)
{ }


SoundDecoder::SoundDecoder():
	source(0),
	freq(0),
	size(0),
	format(MONO8),
	eof_flag(false)
{ }

SoundDecoder::~SoundDecoder()
{
	delete source;
}

SoundDecoder *SoundDecoder::open_file(const string &fn)
{
	RefPtr<IO::BufferedFile> file = new IO::BufferedFile(fn);
	SoundDecoder *decoder = new OggDecoder(*file);
	decoder->source = file.release();
	return decoder;
}

SoundDecoder *SoundDecoder::open_io(IO::Seekable &io)
{
	return new OggDecoder(io);
}

} // namespace AL
} // namespace Msp
