#ifndef MSP_AL_STREAMER_H_
#define MSP_AL_STREAMER_H_

#include <list>
#include "source.h"

namespace Msp {
namespace AL {

class SoundDecoder;
class Buffer;

/**
A streamer transfers data from a SoundDecoder to a Source.  It is permanently
attached to the same Source, but can read from multiple decoders during its
lifetime.
*/
class Streamer
{
private:
	Source &src;
	SoundDecoder *decoder;
	std::list<Buffer *> buffers;

public:
	Streamer(Source &);
	~Streamer();

	void play(SoundDecoder &);
	void stop();
	void tick();
};

} // namespace AL
} // namespace Msp

#endif
